VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form Form1 
   Caption         =   "OeVProjectSample"
   ClientHeight    =   8370
   ClientLeft      =   165
   ClientTop       =   855
   ClientWidth     =   11370
   LinkTopic       =   "Form1"
   ScaleHeight     =   8370
   ScaleWidth      =   11370
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   240
      Top             =   7560
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.PictureBox imageHolder 
      Height          =   8295
      Left            =   120
      ScaleHeight     =   8235
      ScaleWidth      =   11115
      TabIndex        =   0
      Top             =   0
      Width           =   11175
   End
   Begin VB.Menu LoadImage 
      Caption         =   "Load Image"
   End
   Begin VB.Menu Help 
      Caption         =   "Help"
      Begin VB.Menu ApplicationIntroduction 
         Caption         =   "Application Introduction..."
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False


' +-------------------------------- DISCLAIMER ---------------------------------+
' |                                                                             |
' | This application program is provided to you free of charge as an example.   |
' | Despite the considerable efforts of Euresys personnel to create a usable    |
' | example, you should not assume that this program is error-free or suitable  |
' | for any purpose whatsoever.                                                 |
' |                                                                             |
' | EURESYS does not give any representation, warranty or undertaking that this |
' | program is free of any defect or error or suitable for any purpose. EURESYS |
' | shall not be liable, in contract, in torts or otherwise, for any damages,   |
' | loss, costs, expenses or other claims for compensation, including those     |
' | asserted by third parties, arising out of or in connection with the use of  |
' | this program.                                                               |
' |                                                                             |
' +-----------------------------------------------------------------------------+


Option Explicit

' Open eVision objects
Dim easyInstance As New Easy
Dim myImage As New EImageBW8
Dim myRoi As New EROIBW8
Dim myHandle As EDragHandle


Private Sub ApplicationIntroduction_Click()
  
  ' Welcome message box
  Dim strMsg As String
  
    strMsg = "Load an image, then use your mouse to drag and resize the ROI." + vbCrLf + vbCrLf
    strMsg = strMsg + "Suggested image: any gray level image." + vbCrLf
    strMsg = strMsg + "Required licences: Any."
    MsgBox strMsg, vbInformation

End Sub

Private Sub Form_Load()
  
    On Error GoTo Failure
    
    ' Welcome message box
    ApplicationIntroduction_Click
    
    ' Attach the ROI to the image
    myRoi.Attach myImage
   
    ' Set the current handle to none
    myHandle = EDragHandle_NoHandle
    
    On Error GoTo 0
    Exit Sub
    
Failure:
    ' Display the error description
    MsgBox "Error: " & Err.Description, vbOKOnly, "OeVProjectSample"
    
End Sub

Private Sub LoadImage_Click()
   ' Note : The CommonDialog control was inserted by using the
   ' -----   Microsoft Common Dialog Control component

    On Error GoTo Failure

    ' Display the Open dialog box
    CommonDialog1.ShowOpen
    
    If CommonDialog1.FileName = "" Then
        Exit Sub
    End If
    
    ' Load the selected image
    myImage.Load CommonDialog1.FileName
    
    'Set the ROI position and size
    myRoi.SetPlacement myImage.Width / 4, myImage.Height / 4, myImage.Width / 2, myImage.Height / 2
                
    ' Redraw the image
    imageHolder.Refresh
    
    
    '----------------------------------------
    '
    ' Insert the image processing code here.
    '
    '----------------------------------------
    
    
    
    On Error GoTo 0
    Exit Sub
    
Failure:
    ' Display the error description
    MsgBox "Error: " & Err.Description, vbOKOnly, "OeVProjectSample"
    
End Sub


Private Sub imageHolder_Paint()
'Called each time the image is redrawn
 
    On Error GoTo Failure
 
 
    'Prevent flicker
    imageHolder.AutoRedraw = True
    imageHolder.Cls
 
    ' Draw the image into the PictureBox
    myImage.Draw imageHolder.hDC
   
    ' Draw the ROI frame with its handles
    myRoi.DrawFrame imageHolder.hDC, True
   
    'Prevent flicker
    imageHolder.Refresh
    imageHolder.AutoRedraw = False
    
    On Error GoTo 0
    Exit Sub
    
Failure:
    If (Err.Number = EError_LicenseMissing) Then
        ' Display the error description
        MsgBox "Error: " & Err.Description, vbOKOnly, "OeVProjectSample"
    End If
    
End Sub


Private Sub imageHolder_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
   
    On Error GoTo Failure
    
    ' Test if an image was created
    If myImage.IsVoid() Then
       Exit Sub
    End If
     
    ' Transform x and y from twips to pixels
    X = ScaleX(X, vbTwips, vbPixels)
    Y = ScaleY(Y, vbTwips, vbPixels)
   
    ' Drag the ROI borders (mouse down) or set the cursor (mouse up)
    If (Button = vbLeftButton) Then
       ' Mouse button down, drag the ROI border
       If (myHandle <> EDragHandle_NoHandle) Then
         ' Drag the ROI border
         myRoi.Drag myHandle, X, Y
       
         ' Redraw the image
         imageHolder.Refresh
       
       End If
    End If
    
    ' Change the cursor shape according to the handle
    Select Case myRoi.HitTest(X, Y)
      Case EDragHandle_North: MousePointer = vbSizeNS
      Case EDragHandle_South: MousePointer = vbSizeNS
      Case EDragHandle_West: MousePointer = vbSizeWE
      Case EDragHandle_East: MousePointer = vbSizeWE
      Case EDragHandle_NorthEast: MousePointer = vbSizeNESW
      Case EDragHandle_SouthWest: MousePointer = vbSizeNESW
      Case EDragHandle_NorthWest: MousePointer = vbSizeNWSE
      Case EDragHandle_SouthEast: MousePointer = vbSizeNWSE
      Case EDragHandle_Inside: MousePointer = vbSizeAll
      Case EDragHandle_NoHandle: MousePointer = vbArrow
    End Select
  
    On Error GoTo 0
    Exit Sub
    
Failure:
    If (Err.Number = EError_LicenseMissing) Then
        ' Display the error description
        MsgBox "Error: " & Err.Description, vbOKOnly, "OeVProjectSample"
    End If
    
End Sub


Private Sub imageHolder_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    
    On Error GoTo Failure
    
    ' Switch from the up to the down button position
    ' Test if an image was created
    If myImage.IsVoid() Then
       Exit Sub
    End If
     
    ' Transform x and y from twips to pixels
    X = ScaleX(X, vbTwips, vbPixels)
    Y = ScaleY(Y, vbTwips, vbPixels)

    ' Get current handle under mouse cursor
    myHandle = myRoi.HitTest(X, Y)
   
    On Error GoTo 0
    Exit Sub
    
Failure:
    
    If (Err.Number = EError_LicenseMissing) Then
        ' Display the error description
        MsgBox "Error: " & Err.Description, vbOKOnly, "OeVProjectSample"
    End If
    
    
End Sub


Private Sub imageHolder_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
  myHandle = EDragHandle_NoHandle
End Sub
