Imports Euresys.Open_eVision_1_2

Public Class Form1

    ' Open eVision objects
    Dim _image As New EImageBW8
    Dim _roi As New EROIBW8
    Dim _handle As EDragHandle

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load


        ' Introduction message
        Dim strMsg As String
        strMsg = "Load an image, then use your mouse to drag and resize the ROI." + vbCrLf + vbCrLf
        strMsg = strMsg + "Suggested image: Any gray level image." + vbCrLf
        strMsg = strMsg + "Required licences: Any"
        MsgBox(strMsg, vbInformation)

        ' Initialize the ROI handle to 'NoHandle' 
        _handle = EDragHandle.NoHandle

    End Sub

    Private Sub Form1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseDown

        ' If the ROI is empty, exit
        If _roi.IsVoid Then
            Exit Sub
        End If

        ' Get the ROI handle under the cursor
        _handle = _roi.HitTest(e.X, e.Y)

    End Sub

    Private Sub Form1_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseMove

        ' If the ROI is empty, exit
        If _roi.IsVoid Then
            Exit Sub
        End If

        ' If there is a handle under the cursor...
        If (_handle <> EDragHandle.NoHandle) Then

            ' Drag the ROI handle to the cursor position
            _roi.Drag(_handle, e.X, e.Y)

            ' Refresh the form
            Redraw(CreateGraphics())
        End If

        ' Change the cursor shape
        Select Case _roi.HitTest(e.X, e.Y)
            Case EDragHandle.North : Cursor = Cursors.SizeNS
            Case EDragHandle.South : Cursor = Cursors.SizeNS
            Case EDragHandle.West : Cursor = Cursors.SizeWE
            Case EDragHandle.East : Cursor = Cursors.SizeWE
            Case EDragHandle.NorthEast : Cursor = Cursors.SizeNESW
            Case EDragHandle.SouthWest : Cursor = Cursors.SizeNESW
            Case EDragHandle.NorthWest : Cursor = Cursors.SizeNWSE
            Case EDragHandle.SouthEast : Cursor = Cursors.SizeNWSE
            Case EDragHandle.Inside : Cursor = Cursors.SizeAll
            Case EDragHandle.NoHandle : Cursor = Cursors.Arrow
        End Select

    End Sub

    Private Sub Form1_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseUp

        ' Reset the current handle to 'NoHandle'
        _handle = EDragHandle.NoHandle

    End Sub


    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint

        ' Redraw the form content
        Redraw(e.Graphics)

    End Sub

    Private Sub Redraw(ByVal g As Graphics)

        ' If the image is empty, exit
        If _image.IsVoid Then
            Return
        End If

        Try
            ' Draw the image
            _image.Draw(g)

            ' Draw the ROI frame
            _roi.DrawFrame(g, True)

        Catch exc As EException
            MessageBox.Show(Err.Description)
        End Try

    End Sub

    Private Sub OpenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenToolStripMenuItem.Click

        ' Initialize the 'File Open' dialog box
        OpenFileDialog1.Filter = "Image Files(*.BMP;*.JPG;*.TIF;*.PNG)|*.BMP;*.JPG;*.TIF;*.PNG"
        OpenFileDialog1.FileName = ""
        If OpenFileDialog1.ShowDialog() = DialogResult.Cancel Then
            Return
        End If

        Try
            ' Load the selected image
            _image.Load(OpenFileDialog1.FileName)

            ' Attach the ROI to the image
            _roi.Attach(_image)

            ' Set the ROI position and size
            _roi.SetPlacement(_image.Width / 4, _image.Height / 4, _image.Width / 2, _image.Height / 2)

        Catch exc As EException
            MessageBox.Show(Err.Description)
        End Try

        ' Refresh the form
        Refresh()

    End Sub

    Private Sub ApplicationIntroductionToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ApplicationIntroductionToolStripMenuItem.Click

        ' Introduction message
        Dim strMsg As String
        strMsg = "Load an image, then use your mouse to drag and resize the ROI." + vbCrLf + vbCrLf
        strMsg = strMsg + "Suggested image: Any gray level image." + vbCrLf
        strMsg = strMsg + "Required licences: Any"
        MsgBox(strMsg, vbInformation)

    End Sub

    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click

        ' Close the form
        Close()

    End Sub
End Class
