// +-------------------------------- DISCLAIMER ---------------------------------+
// |                                                                             |
// | This application program is provided to you free of charge as an example.   |
// | Despite the considerable efforts of Euresys personnel to create a usable    |
// | example, you should not assume that this program is error-free or suitable  |
// | for any purpose whatsoever.                                                 |
// |                                                                             |
// | EURESYS does not give any representation, warranty or undertaking that this |
// | program is free of any defect or error or suitable for any purpose. EURESYS |
// | shall not be liable, in contract, in torts or otherwise, for any damages,   |
// | loss, costs, expenses or other claims for compensation, including those     |
// | asserted by third parties, arising out of or in connection with the use of  |
// | this program.                                                               |
// |                                                                             |
// +-----------------------------------------------------------------------------+


// OeVProjectSampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "OeVProjectSample.h"
#include "OeVProjectSampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COeVProjectSampleDlg dialog

COeVProjectSampleDlg::COeVProjectSampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COeVProjectSampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(COeVProjectSampleDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);


	try
	{
		_roi.Attach(&_image);
	}
	catch(EException exc)
	{
		::MessageBox(NULL, exc.What().c_str(), "OeVProjectSample", MB_OK);		
	}
}

void COeVProjectSampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COeVProjectSampleDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(COeVProjectSampleDlg, CDialog)
	//{{AFX_MSG_MAP(COeVProjectSampleDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(ID_FILES_LOAD, OnFilesLoad)
	ON_COMMAND(ID_FILES_EXIT, OnFilesExit)
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COeVProjectSampleDlg message handlers

BOOL COeVProjectSampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void COeVProjectSampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void COeVProjectSampleDlg::OnPaint() 
{
		CPaintDC dc(this); // device context for painting
   
		// Retrieve the handle to the Device Context
		HDC hdc= dc.GetSafeHdc();

		try
		{
			// If the image has not been loaded yet, do nothing
			if (_image.IsVoid())
				return;
			// Draw the image
			_image.Draw(hdc);
			
			// Draw the ROI with its handles
			_roi.DrawFrame(hdc, TRUE);







		}
		catch(EException exc)
		{
			if (exc.GetError() != EError_LicenseMissing)
			{
				::MessageBox(NULL, exc.What().c_str(), "OeVProjectSample", MB_OK);
			}
		}

	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();

			CDialog::OnPaint();

   
		// Retrieve the handle to the Device Context
		HDC hdc= dc.GetSafeHdc();

		try
		{
			// If the image has not been loaded yet, do nothing
			if (_image.IsVoid())
				return;
			// Draw the image
			_image.Draw(hdc);
			
			// Draw the ROI with its handles
			_roi.DrawFrame(hdc, TRUE);







		}
		catch(EException exc)
		{
			if (exc.GetError() != EError_LicenseMissing)
			{
				::MessageBox(NULL, exc.What().c_str(), "OeVProjectSample", MB_OK);
			}
		}

	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR COeVProjectSampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void COeVProjectSampleDlg::OnFilesLoad() 
{
	// TODO: Add your command handler code here
		
	char strFilter[] = { "Bitmap Files (*.bmp)|*.bmp|All Files (*.*)|*.*||" };

	CFileDialog FileDlg(TRUE, ".bmp", NULL, 0, strFilter);

	if( FileDlg.DoModal() == IDOK )
	{
		try
		{
			// Load the selected image
			_image.Load((LPCTSTR)FileDlg.GetPathName());  

			
			// Set the ROI position and size
			_roi.SetPlacement(_image.GetWidth() / 4, _image.GetHeight() / 4,
							  _image.GetWidth() / 2, _image.GetHeight() / 2);


			//----------------------------------------
			//
			// Insert the image processing code here.
			//
			//----------------------------------------


		}
		catch(EException exc)
		{
			::MessageBox(NULL, exc.What().c_str(), "OeVProjectSample", MB_OK);
		}

		// Refresh the window
		Invalidate();
	}
	
}

void COeVProjectSampleDlg::OnFilesExit() 
{
	// TODO: Add your command handler code here
	EndDialog(0);
}

void COeVProjectSampleDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	// This is where all the management of the ROI limits occurs
  
	// Retrieve the ROI from the Document
	try
	{
		if (!_roi.IsVoid())
		{
			// Drag the ROI borders (mouse down) or set the cursor (mouse up)
			if (nFlags & MK_LBUTTON)
			{
				// Drag
				_roi.Drag(_handle, point.x, point.y);
				
				Invalidate(FALSE);
			}
			else
			{
				// Detect the handle under the cursor
				_handle= _roi.HitTest(point.x, point.y);
			}

			// Change the cursor shape according to the handle
			switch (_handle)
			{
				case EDragHandle_Inside:
				  SetCursor(LoadCursor(NULL, IDC_SIZEALL));
				  break;
		  
				case EDragHandle_North:
				case EDragHandle_South:
				  SetCursor(LoadCursor(NULL, IDC_SIZENS));
				  break;
		  
				case EDragHandle_East:
				case EDragHandle_West:
				  SetCursor(LoadCursor(NULL, IDC_SIZEWE));
				  break;
		  
				case EDragHandle_NorthWest:
				case EDragHandle_SouthEast:
				  SetCursor(LoadCursor(NULL, IDC_SIZENWSE));
				  break;
		  
				case EDragHandle_NorthEast:
				case EDragHandle_SouthWest:
				  SetCursor(LoadCursor(NULL, IDC_SIZENESW));
			}
		}
	}
	catch(EException exc)
	{
		if (exc.GetError() != EError_LicenseMissing)
		{
			::MessageBox(NULL, exc.What().c_str(), "OeVProjectSample", MB_OK);
		}
	}


	CDialog::OnMouseMove(nFlags, point);
}
